#pragma once
 
#include "resource.h"
#include "VS2005ISSetupExampleShim.h"
 
class ATL_NO_VTABLE CProxy :
    public CComObjectRootEx<CComSingleThreadModel>,
    public CComCoClass<CProxy, &CLSID_Proxy>,
    public IDispatchImpl<_IDTExtensibility2, &IID__IDTExtensibility2, &LIBID_AddInDesignerObjects, /* wMajor = */ 1, /* wMinor = */ 0>
{
public:
    CProxy()
        : m_pConnect(NULL)
    {
    }
 
    DECLARE_REGISTRY_RESOURCEID(IDR_PROXY)
 
    BEGIN_COM_MAP(CProxy)
        COM_INTERFACE_ENTRY2(IDispatch, IDTExtensibility2)
        COM_INTERFACE_ENTRY(IDTExtensibility2)
    END_COM_MAP()
 
    DECLARE_PROTECT_FINAL_CONSTRUCT()
 
    HRESULT FinalConstruct();
    void FinalRelease();
 
public:
    STDMETHOD(OnConnection)(IDispatch * Application, ext_ConnectMode ConnectMode, IDispatch *AddInInst, SAFEARRAY **custom)
    {
        if (m_pConnect != NULL)
            return m_pConnect->OnConnection(Application, ConnectMode, AddInInst, custom);
        return S_OK;
    }
    STDMETHOD(OnDisconnection)(ext_DisconnectMode RemoveMode, SAFEARRAY **custom )
    {
        if (m_pConnect != NULL)
            return m_pConnect->OnDisconnection(RemoveMode, custom);
        return S_OK;
    }
    STDMETHOD(OnAddInsUpdate)(SAFEARRAY **custom )
    {
        if (m_pConnect != NULL)
            return m_pConnect->OnAddInsUpdate(custom);
        return S_OK;
    }
    STDMETHOD(OnStartupComplete)(SAFEARRAY **custom )
    {
        if (m_pConnect != NULL)
            return m_pConnect->OnStartupComplete(custom);
        return S_OK;
    }
    STDMETHOD(OnBeginShutdown)(SAFEARRAY **custom )
    {
        if (m_pConnect != NULL)
            return m_pConnect->OnBeginShutdown(custom);
        return S_OK;
    }
 
protected:
    IDTExtensibility2 *m_pConnect;
};
 
OBJECT_ENTRY_AUTO(__uuidof(Proxy), CProxy)

